/*===========================================================================*/
/*   (Llib/kmp.scm)                                                          */
/*   Bigloo (2.8c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Wed Sep 13 14:17:01 CEST 2006       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -lib-dir /users/serrano/prgm/project/bigloo/lib/2.8c -cg -O4 -mklib -cc gcc -fsharing -q -no-hello -copt -DBGL_NO_PIC -unsafe -c Llib/kmp.scm -indent -o objs/obj_u/Llib/kmp.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__kmpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl__kmpzd2table2579zd2zz__kmpz00(obj_t, obj_t);
	BGL_EXPORTED_DECL long BGl_kmpzd2mmapzd2zz__kmpz00(obj_t, obj_t, long);
	BGL_EXPORTED_DECL obj_t BGl_kmpzd2tablezd2zz__kmpz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__kmpz00 = BUNSPEC;
	extern obj_t make_vector(int, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__kmpz00();
	BGL_EXPORTED_DECL long BGl_kmpzd2stringzd2zz__kmpz00(obj_t, char *, long);
	static obj_t BGl__kmpzd2string2583zd2zz__kmpz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t string_to_bstring(char *);
	static obj_t BGl__kmpzd2mmap2581zd2zz__kmpz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_kmpzd2stringzd2envz00zz__kmpz00,
		BgL_bgl__kmpza7d2string2583za7d2za7za7__kmpza7002643za7,
		BGl__kmpzd2string2583zd2zz__kmpz00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_kmpzd2mmapzd2envz00zz__kmpz00,
		BgL_bgl__kmpza7d2mmap2581za7d2za7za7__kmpza7002644za7,
		BGl__kmpzd2mmap2581zd2zz__kmpz00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_kmpzd2tablezd2envz00zz__kmpz00,
		BgL_bgl__kmpza7d2table2579za7d2za7za7__kmpza7002645za7,
		BGl__kmpzd2table2579zd2zz__kmpz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2638z00zz__kmpz00,
		BgL_bgl_string2638za700za7za7__kmpza7002646z00, "__kmp", 5);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__kmpz00(long
		BgL_checksumz00_1002, char *BgL_fromz00_1003)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__kmpz00))
				{
					BGl_requirezd2initializa7ationz75zz__kmpz00 = BBOOL(((bool_t) 0));
					BGl_importedzd2moduleszd2initz00zz__kmpz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* kmp-table */
	BGL_EXPORTED_DEF obj_t BGl_kmpzd2tablezd2zz__kmpz00(obj_t BgL_pz00_1)
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 46 */
			{	/* Llib/kmp.scm 47 */
				long BgL_lpz00_451;

				BgL_lpz00_451 = STRING_LENGTH(BgL_pz00_1);
				{	/* Llib/kmp.scm 47 */
					obj_t BgL_tz00_452;

					{	/* Llib/kmp.scm 48 */
						long BgL_arg1520z00_465;

						BgL_arg1520z00_465 = (BgL_lpz00_451 + ((long) 2));
						BgL_tz00_452 =
							make_vector((int) (BgL_arg1520z00_465), BINT(((long) 0)));
					}
					{	/* Llib/kmp.scm 48 */
						long BgL_iz00_453;

						BgL_iz00_453 = ((long) 0);
						{	/* Llib/kmp.scm 49 */
							obj_t BgL_jz00_454;

							BgL_jz00_454 = BINT(((long) -1));
							{	/* Llib/kmp.scm 50 */
								unsigned char BgL_cz00_455;

								BgL_cz00_455 = ((unsigned char) '\000');
								{	/* Llib/kmp.scm 51 */

									VECTOR_SET(BgL_tz00_452, (int) (((long) 0)), BgL_jz00_454);
									{

									BgL_whilez00_456:
										if ((BgL_iz00_453 < BgL_lpz00_451))
											{	/* Llib/kmp.scm 54 */
												{	/* Llib/kmp.scm 56 */
													bool_t BgL_testz00_1018;

													{	/* Llib/kmp.scm 56 */
														unsigned char BgL_char2z00_776;

														BgL_char2z00_776 = BgL_cz00_455;
														BgL_testz00_1018 =
															(STRING_REF(BgL_pz00_1,
																BgL_iz00_453) == BgL_char2z00_776);
													}
													if (BgL_testz00_1018)
														{	/* Llib/kmp.scm 56 */
															{	/* Llib/kmp.scm 57 */
																long BgL_arg1492z00_459;
																long BgL_arg1493z00_460;

																BgL_arg1492z00_459 =
																	(BgL_iz00_453 + ((long) 1));
																BgL_arg1493z00_460 =
																	((long) CINT(BgL_jz00_454) + ((long) 1));
																VECTOR_SET(BgL_tz00_452,
																	(int) (BgL_arg1492z00_459),
																	BINT(BgL_arg1493z00_460));
															}
															{	/* Llib/kmp.scm 58 */
																long BgL_za71za7_784;

																BgL_za71za7_784 = (long) CINT(BgL_jz00_454);
																BgL_jz00_454 =
																	BINT((BgL_za71za7_784 + ((long) 1)));
															}
															BgL_iz00_453 = (BgL_iz00_453 + ((long) 1));
														}
													else
														{	/* Llib/kmp.scm 56 */
															if (((long) CINT(BgL_jz00_454) > ((long) 0)))
																{	/* Llib/kmp.scm 60 */
																	BgL_jz00_454 =
																		VECTOR_REF(BgL_tz00_452,
																		CINT(BgL_jz00_454));
																}
															else
																{	/* Llib/kmp.scm 60 */
																	{	/* Llib/kmp.scm 63 */
																		long BgL_arg1504z00_462;

																		BgL_arg1504z00_462 =
																			(BgL_iz00_453 + ((long) 1));
																		VECTOR_SET(BgL_tz00_452,
																			(int) (BgL_arg1504z00_462),
																			BINT(((long) 0)));
																	}
																	BgL_iz00_453 = (BgL_iz00_453 + ((long) 1));
																	BgL_jz00_454 = BINT(((long) 0));
												}}}
												BgL_cz00_455 =
													STRING_REF(BgL_pz00_1, (long) CINT(BgL_jz00_454));
												goto BgL_whilez00_456;
											}
										else
											{	/* Llib/kmp.scm 54 */
												((bool_t) 0);
											}
									}
									return MAKE_PAIR(BgL_tz00_452, BgL_pz00_1);
								}
							}
						}
					}
				}
			}
		}
	}



/* _kmp-table2579 */
	obj_t BGl__kmpzd2table2579zd2zz__kmpz00(obj_t BgL_envz00_992,
		obj_t BgL_pz00_993)
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 46 */
			return BGl_kmpzd2tablezd2zz__kmpz00(BgL_pz00_993);
		}
	}



/* kmp-mmap */
	BGL_EXPORTED_DEF long BGl_kmpzd2mmapzd2zz__kmpz00(obj_t BgL_tpz00_2,
		obj_t BgL_mmz00_3, long BgL_mz00_4)
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 73 */
			{	/* Llib/kmp.scm 74 */
				obj_t BgL_tz00_467;

				BgL_tz00_467 = CAR(BgL_tpz00_2);
				{	/* Llib/kmp.scm 74 */
					obj_t BgL_pz00_468;

					BgL_pz00_468 = CDR(BgL_tpz00_2);
					{	/* Llib/kmp.scm 75 */
						long BgL_lsz00_469;

						BgL_lsz00_469 = BGL_MMAP_LENGTH(BgL_mmz00_3);
						{	/* Llib/kmp.scm 76 */
							long BgL_lpz00_470;

							BgL_lpz00_470 = STRING_LENGTH(BgL_pz00_468);
							{	/* Llib/kmp.scm 77 */

								{
									obj_t BgL_iz00_471;

									BgL_iz00_471 = BINT(((long) 0));
								BgL_whilez00_472:
									if (((long) CINT(BgL_iz00_471) == BgL_lpz00_470))
										{	/* Llib/kmp.scm 80 */
											return BgL_mz00_4;
										}
									else
										{	/* Llib/kmp.scm 82 */
											bool_t BgL_testz00_1053;

											{	/* Llib/kmp.scm 82 */
												long BgL_n2z00_810;

												BgL_n2z00_810 = ELONG_TO_LONG(BgL_lsz00_469);
												{	/* Llib/kmp.scm 82 */
													long BgL_auxz00_1055;

													{	/* Llib/kmp.scm 82 */
														long BgL_za71za7_807;
														long BgL_za72za7_808;

														BgL_za71za7_807 = (long) CINT(BgL_iz00_471);
														BgL_za72za7_808 = ELONG_TO_LONG(BgL_mz00_4);
														BgL_auxz00_1055 =
															(BgL_za71za7_807 + BgL_za72za7_808);
													}
													BgL_testz00_1053 = (BgL_auxz00_1055 >= BgL_n2z00_810);
											}}
											if (BgL_testz00_1053)
												{	/* Llib/kmp.scm 82 */
													return ((long) -1);
												}
											else
												{	/* Llib/kmp.scm 85 */
													bool_t BgL_testz00_1060;

													{	/* Llib/kmp.scm 85 */
														unsigned char BgL_arg1545z00_480;
														unsigned char BgL_arg1546z00_481;

														{	/* Llib/kmp.scm 85 */
															long BgL_arg1553z00_482;

															{	/* Llib/kmp.scm 85 */
																long BgL_za71za7_811;
																long BgL_za72za7_812;

																BgL_za71za7_811 = (long) CINT(BgL_iz00_471);
																BgL_za72za7_812 = ELONG_TO_LONG(BgL_mz00_4);
																BgL_arg1553z00_482 =
																	(BgL_za71za7_811 + BgL_za72za7_812);
															}
															{	/* Llib/kmp.scm 85 */
																long BgL_auxz00_1064;

																BgL_auxz00_1064 =
																	LONG_TO_ELONG(BgL_arg1553z00_482);
																BgL_arg1545z00_480 =
																	BGL_MMAP_REF(BgL_mmz00_3, BgL_auxz00_1064);
														}}
														BgL_arg1546z00_481 =
															STRING_REF(BgL_pz00_468,
															(long) CINT(BgL_iz00_471));
														BgL_testz00_1060 =
															(BgL_arg1545z00_480 == BgL_arg1546z00_481);
													}
													if (BgL_testz00_1060)
														{	/* Llib/kmp.scm 86 */
															long BgL_arg1531z00_476;

															BgL_arg1531z00_476 =
																((long) CINT(BgL_iz00_471) + ((long) 1));
															{
																obj_t BgL_iz00_1072;

																BgL_iz00_1072 = BINT(BgL_arg1531z00_476);
																BgL_iz00_471 = BgL_iz00_1072;
																goto BgL_whilez00_472;
															}
														}
													else
														{	/* Llib/kmp.scm 87 */
															obj_t BgL_tiz00_477;

															BgL_tiz00_477 =
																VECTOR_REF(BgL_tz00_467, CINT(BgL_iz00_471));
															{	/* Llib/kmp.scm 88 */
																long BgL_za71za7_823;

																BgL_za71za7_823 = ELONG_TO_LONG(BgL_mz00_4);
																{	/* Llib/kmp.scm 88 */
																	long BgL_auxz00_1077;

																	BgL_auxz00_1077 =
																		(BgL_za71za7_823 +
																		((long) CINT(BgL_iz00_471) -
																			(long) CINT(BgL_tiz00_477)));
																	BgL_mz00_4 = LONG_TO_ELONG(BgL_auxz00_1077);
															}}
															if (((long) CINT(BgL_iz00_471) > ((long) 0)))
																{
																	obj_t BgL_iz00_1086;

																	BgL_iz00_1086 = BgL_tiz00_477;
																	BgL_iz00_471 = BgL_iz00_1086;
																	goto BgL_whilez00_472;
																}
															else
																{

																	goto BgL_whilez00_472;
																}
														}
												}
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* _kmp-mmap2581 */
	obj_t BGl__kmpzd2mmap2581zd2zz__kmpz00(obj_t BgL_envz00_994,
		obj_t BgL_tpz00_995, obj_t BgL_mmz00_996, obj_t BgL_mz00_997)
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 73 */
			{	/* Llib/kmp.scm 74 */
				long BgL_auxz00_1088;

				BgL_auxz00_1088 =
					BGl_kmpzd2mmapzd2zz__kmpz00(BgL_tpz00_995, BgL_mmz00_996,
					BELONG_TO_LONG(BgL_mz00_997));
				return LONG_TO_BELONG(BgL_auxz00_1088);
			}
		}
	}



/* kmp-string */
	BGL_EXPORTED_DEF long BGl_kmpzd2stringzd2zz__kmpz00(obj_t BgL_tpz00_5,
		char *BgL_strz00_6, long BgL_mz00_7)
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 96 */
			{	/* Llib/kmp.scm 97 */
				obj_t BgL_tz00_484;

				BgL_tz00_484 = CAR(BgL_tpz00_5);
				{	/* Llib/kmp.scm 97 */
					obj_t BgL_pz00_485;

					BgL_pz00_485 = CDR(BgL_tpz00_5);
					{	/* Llib/kmp.scm 98 */
						long BgL_lsz00_486;

						BgL_lsz00_486 = STRING_LENGTH(string_to_bstring(BgL_strz00_6));
						{	/* Llib/kmp.scm 99 */
							long BgL_lpz00_487;

							BgL_lpz00_487 = STRING_LENGTH(BgL_pz00_485);
							{	/* Llib/kmp.scm 100 */

								{
									obj_t BgL_iz00_488;

									BgL_iz00_488 = BINT(((long) 0));
								BgL_whilez00_489:
									if (((long) CINT(BgL_iz00_488) == BgL_lpz00_487))
										{	/* Llib/kmp.scm 103 */
											return BgL_mz00_7;
										}
									else
										{	/* Llib/kmp.scm 103 */
											if (
												(((long) CINT(BgL_iz00_488) + BgL_mz00_7) >=
													BgL_lsz00_486))
												{	/* Llib/kmp.scm 105 */
													return ((long) -1);
												}
											else
												{	/* Llib/kmp.scm 108 */
													bool_t BgL_testz00_1104;

													{	/* Llib/kmp.scm 108 */
														unsigned char BgL_arg1596z00_497;

														{	/* Llib/kmp.scm 108 */
															obj_t BgL_stringz00_839;

															BgL_stringz00_839 =
																string_to_bstring(BgL_strz00_6);
															BgL_arg1596z00_497 =
																STRING_REF(BgL_stringz00_839,
																((long) CINT(BgL_iz00_488) + BgL_mz00_7));
														}
														BgL_testz00_1104 =
															(BgL_arg1596z00_497 ==
															STRING_REF(BgL_pz00_485,
																(long) CINT(BgL_iz00_488)));
													}
													if (BgL_testz00_1104)
														{	/* Llib/kmp.scm 109 */
															long BgL_arg1572z00_493;

															BgL_arg1572z00_493 =
																((long) CINT(BgL_iz00_488) + ((long) 1));
															{
																obj_t BgL_iz00_1114;

																BgL_iz00_1114 = BINT(BgL_arg1572z00_493);
																BgL_iz00_488 = BgL_iz00_1114;
																goto BgL_whilez00_489;
															}
														}
													else
														{	/* Llib/kmp.scm 110 */
															obj_t BgL_tiz00_494;

															BgL_tiz00_494 =
																VECTOR_REF(BgL_tz00_484, CINT(BgL_iz00_488));
															BgL_mz00_7 =
																(BgL_mz00_7 +
																((long) CINT(BgL_iz00_488) -
																	(long) CINT(BgL_tiz00_494)));
															if (((long) CINT(BgL_iz00_488) > ((long) 0)))
																{
																	obj_t BgL_iz00_1125;

																	BgL_iz00_1125 = BgL_tiz00_494;
																	BgL_iz00_488 = BgL_iz00_1125;
																	goto BgL_whilez00_489;
																}
															else
																{

																	goto BgL_whilez00_489;
																}
														}
												}
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* _kmp-string2583 */
	obj_t BGl__kmpzd2string2583zd2zz__kmpz00(obj_t BgL_envz00_998,
		obj_t BgL_tpz00_999, obj_t BgL_strz00_1000, obj_t BgL_mz00_1001)
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 96 */
			return
				BINT(BGl_kmpzd2stringzd2zz__kmpz00(BgL_tpz00_999,
					BSTRING_TO_STRING(BgL_strz00_1000), (long) CINT(BgL_mz00_1001)));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__kmpz00()
	{
		AN_OBJECT;
		{	/* Llib/kmp.scm 15 */
			return
				BGl_modulezd2initializa7ationz75zz__errorz00(((long) 215971449),
				BSTRING_TO_STRING(BGl_string2638z00zz__kmpz00));
		}
	}

#ifdef __cplusplus
}
#endif
